#include <sys/types.h>
#include <sys/socket.h>
#include <sys/select.h>
#include <netinet/in.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

static int wrap_err(int ret)
{
    if (ret < 0) {
        fprintf(stderr, "ERROR: %s\n", strerror(errno));
        exit(-1);
    }
    return ret;
}

int main()
{
    struct sockaddr_in local_addr = {
        .sin_family = AF_INET,
        .sin_port = 0, // Pick whatever free local port
        .sin_addr = 0x0100007F, // 127.0.0.1
    };
    socklen_t addr_len = sizeof(local_addr);
    int listener = wrap_err(socket(AF_INET, SOCK_STREAM, 0));
    int conn = wrap_err(socket(AF_INET, SOCK_STREAM, 0));

    wrap_err(bind(listener, (void*)&local_addr, addr_len));
    wrap_err(listen(listener, SOMAXCONN));
    wrap_err(getsockname(listener, (void*)&local_addr, &addr_len));
    wrap_err(connect(conn, (void*)&local_addr, addr_len));

    int client = wrap_err(accept(listener, (void*)&local_addr, &addr_len));

    // At this point we have 2 connected socket and no longer need a listener
    close(listener);

    fd_set rfds;
    FD_ZERO(&rfds);
    FD_SET(client, &rfds); // Watch for events on client socket

    close(conn); // Simulate a disconnect, implicity does shutdown()

    printf("Calling select(), this will hang on Haiku\n");
    select(client + 1, &rfds, NULL, NULL, NULL); // On Haiku we never wake up...

    close(client); // I hope we get here eventually..

    printf("Test passed!\n");
}
